
angular.module('comprecar.cidade.ctrl', [])


        .controller('CidadeController', ['$scope', '$ionicLoading', '$rootScope', '$state', '$ionicViewService', '$cordovaDialogs', '$ionicNavBarDelegate', 'Cities', '$stateParams', '$localstorage', '$ionicScrollDelegate', function ($scope, $ionicLoading, $rootScope, $state, $ionicViewService, $cordovaDialogs, $ionicNavBarDelegate, Cities, $stateParams, $localstorage, $ionicScrollDelegate) {

                $scope.data = {};
                $scope.itemsCity = [];
                $scope.data.city = $localstorage.get('city', "Todas");
                $scope.data.city_id = $localstorage.get('city_id', "");
                $scope.data.type_id = $localstorage.get('type_id', "");

                $ionicLoading.show({
                    template: '<i class="icon ion-loading-c"></i><br />',
                    animation: 'fade-in',
                    showBackdrop: true
                });
                
                Cities.getByType($scope.data.type_id)
                        .success(function (data) {
                            $scope.itemsCity.push({codigo:'',nome:'Todos'});
                            if (data.status == 1) {
                                // Push all of the commits from response into model.
                                angular.forEach(data.result, function (item) {
                                    $scope.itemsCity.push(item);
                                });

                                setTimeout(function () {
                                    var el = document.querySelector('#radio' + $scope.data.city_id);
                                    var top = el.getBoundingClientRect().bottom;
                                    $ionicScrollDelegate.scrollTo(0, top - 200, true);
                                    
                                    $ionicLoading.hide();
                                });
                                
                                

                            } else if ($rootScope.itemsCity.length == 0) {
                                $cordovaDialogs.alert('Nenhuma cidade encontrada', 'Resultado ', 'Voltar')
                                        .then(function () {
                                            $ionicNavBarDelegate.back();
                                        });
                            }
                        })
                        .error(function (err) {

                            $ionicLoading.hide();
                            if ($scope.items.length == 0) {
                                var msg = (err) ? err.message : 'Verifique sua conexão de dados';
                                $cordovaDialogs.alert(msg, 'Atenção ', 'Voltar')
                                        .then(function () {
                                            $ionicNavBarDelegate.back();
                                        });

                            }

                        });


                $scope.selectCity = function (id, nome) {
                    $localstorage.set('city', nome);
                    $localstorage.set('city_id', id);
                    $ionicNavBarDelegate.back();
                };



                function removeAccents(value) {
                    return value
                            .replace(/á/g, 'a')
                            .replace(/â/g, 'a')
                            .replace(/ã/g, 'a')
                            .replace(/é/g, 'e')
                            .replace(/è/g, 'e')
                            .replace(/ê/g, 'e')
                            .replace(/í/g, 'i')
                            .replace(/ï/g, 'i')
                            .replace(/ì/g, 'i')
                            .replace(/ó/g, 'o')
                            .replace(/ô/g, 'o')
                            .replace(/ú/g, 'u')
                            .replace(/ü/g, 'u')
                            .replace(/ç/g, 'c')
                }

                $scope.ignoreAccents = function (item) {

                    if (!$scope.data.search)
                        return true;

                    var fullName = item.nome;
                    var text = removeAccents(fullName.toLowerCase());
                    var search = removeAccents($scope.data.search.toLowerCase());
                    return text.indexOf(search) > -1;
                };


            }]);