
angular.module('comprecar.menu.ctrl', ['ui.utils.masks'])
        .controller('MenuController', function ($scope, ContactModal, $state, $ionicModal, $timeout, $http, $ionicLoading, AuthenticationService, $ionicScrollDelegate, $cordovaDialogs, $ionicPlatform, User, States, Cities, $localstorage, $cordovaGoogleAnalytics,CONSTANTS) {


            
            if (typeof window.analytics !== "undefined") window.analytics.trackView('Home');
    
    
            // Form registerData for the login modal
            $scope.loginData = {};
            $scope.error = false;

            // Create the login modal that we will use later
            $ionicModal.fromTemplateUrl('app/menu/login.html', {
                scope: $scope,
                animation: 'slide-in-up',
            }).then(function (modal) {
                $scope.loginModal = modal;
            });
            // Triggered in the login modal to close it
            $scope.closeLogin = function () {
                $scope.loginModal.hide();
                $state.go('app.search', {}, {reload: true, inherit: false});
            };
            // Open the login modal
            $scope.login = function () {
                $scope.loginModal.show();
            };

            $scope.user = {
                login: null,
                password: null
            };
            // Perform the login action when the user submits the login form
            $scope.doLogin = function () {
                AuthenticationService.login($scope.user);
            };

            ContactModal.init();


            $scope.$on('event:auth-loginRequired', function (e, rejection) {
                $scope.loginModal.show();
                $ionicLoading.hide();
            });

            $scope.$on('event:auth-loginConfirmed', function () {
                $scope.login = null;
                $scope.password = null;
                $scope.loginModal.hide();
            });

            $scope.$on('event:auth-login-failed', function (e, status) {
                var error = "Falha no login";
                if (status == 401) {
                    error = "Usuario e Senha incorretos";
                }
                $scope.message = error;
            });

            $scope.$on('event:auth-logout-complete', function () {
                $state.go('app.search', {}, {reload: true, inherit: false});
            });



            // Form registerData for the login modal
            $scope.register = {};
            $scope.error = false;

            // Create the login modal that we will use later
            $ionicModal.fromTemplateUrl('app/account/register.html', {
                scope: $scope,
                animation: 'slide-in-right'
            }).then(function (modal) {
                $scope.registerModal = modal;
            });
            // Triggered in the login modal to close it
            $scope.closeRegister = function () {
                $scope.registerModal.hide();
            };

            // Open the login modal
            $scope.openRegister = function () {


                /**
                 * 
                 * Register
                 * 
                 */
                $scope.items = [];
                $scope.registerData = {};
                $scope.registerData.private = {};
                $scope.registerData.store = {};
                $scope.more = true;

                $scope.type = 2;


                $scope.setActive = function (type) {
                    $scope.type = type;
                };

                $scope.isActive = function (type) {
                    return type === $scope.type;
                };
                $scope.registerData.private.email = "";
                $scope.registerData.private.confirma_email = "";
                $scope.registerData.private.senha = "";
                $scope.registerData.private.confirma_senha = "";
                $scope.registerData.store.email = "";
                $scope.registerData.store.confirma_email = "";
                $scope.registerData.store.senha = "";
                $scope.registerData.store.confirma_senha = "";

                States.getAll()
                        .success(function (data) {
                            $ionicLoading.hide();
                            if (data.status == 1) {
                                $scope.itemStates = data.result;
                            }
                        })
                        .error(function (err) {
                            $ionicLoading.hide();
                            if ($scope.itemStates.length == 0) {
                                var msg = (err) ? err.message : 'Verifique sua conexão de dados';
                                $cordovaDialogs.alert(msg, 'Comprecar ', 'Ok');
                            }
                        });
                $scope.selectedState = function () {
                    $ionicLoading.show({
                        template: '<i class="icon ion-loading-c"></i><br />',
                        animation: 'fade-in',
                        showBackdrop: true
                    });
                    Cities.getAll($scope.registerData.private.estado)
                            .success(function (data) {
                                $ionicLoading.hide();
                                if (data.status == 1) {
                                    $scope.itemCities = data.result;

                                }
                            })
                            .error(function (err) {
                                $ionicLoading.hide();
                                if ($scope.itemCities.length == 0) {
                                    var msg = (err) ? err.message : 'Verifique sua conexão de dados';
                                    $cordovaDialogs.alert(msg, 'Atenção ', 'Voltar');
                                }
                            });
                }


                var createUser = function (registerData, type) {
                    $ionicLoading.show({
                        template: '<i class="icon ion-loading-c"></i><br />',
                        animation: 'fade-in',
                        showBackdrop: true
                    });
                    registerData.type = type;

                    User.create(registerData)
                            .success(function (data) {
                                $ionicLoading.hide();
                                $scope.user = data.result;
                                $cordovaDialogs.alert(data.message, 'Comprecar ', 'Ok')
                                        .then(function () {
                                            $scope.registerModal.hide();
                                            $scope.loginModal.hide();

                                            $localstorage.setObject('user', data.result);
                                            AuthenticationService.login(data.result);

                                            $state.go('app.profile', {}, {reload: true, inherit: false});

                                        });


                            })
                            .error(function (data, status, headers, config) {
                                $ionicLoading.hide();

                                var msg = (data.message) ? data.message : 'Verifique sua conexão de dados';
                                $cordovaDialogs.alert(msg, 'Comprecar ', 'Ok')
                                        .then(function () {

                                        });
                            });
                };

                $scope.registerPrivate = function () {
                    if ($scope.validateEmail($scope.registerData.private.email, $scope.registerData.private.confirma_email, 2) && $scope.validatePassword($scope.registerData.private.senha, $scope.registerData.private.comfirma_senha, 2)) {
                        createUser($scope.registerData.private, 2);
                    }
                }
                $scope.registerStore = function () {
                    if ($scope.validateEmail($scope.registerData.store.email, $scope.registerData.store.confirma_email, 1)) {
                        createUser($scope.registerData.store, 1);
                    }
                }


                $scope.validateEmail = function (email, confirm_email, type) {
                    var id_element = (type == 2) ? '#email_private' : '#email_store';
                    if (email != confirm_email || email.length == 0 || confirm_email.length == 0) {
                        $cordovaDialogs.alert('Emails não conferem', 'Comprecar', 'Corrigir').then(function () {

                            $ionicScrollDelegate.scrollTop();
                        });
                        return false;
                    } else {
                        return true;
                    }
                }
                $scope.validatePassword = function (password, confirm_password, type) {
                    var id_element = (type == 2) ? '#password_private' : '#password_store';

                    if (password != confirm_password || password.length == 0 || confirm_password.length == 0) {
                        $cordovaDialogs.alert('Senhas não conferem', 'Comprecar', 'Corrigir').then(function () {

                            $ionicScrollDelegate.scrollTop();
                        });
                        return false
                    } else {
                        return true;
                    }
                }

                // Create the login modal that we will use later
                $ionicModal.fromTemplateUrl('app/account/policy.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    $scope.policyModal = modal;
                });
                // Triggered in the login modal to close it
                $scope.closePolicy = function () {
                    $scope.policyModal.hide();
                };
                // Open the login modal
                $scope.openPolicy = function (type) {
                    $scope.policyModal.show();
                };

                $scope.registerModal.show();
            };


            $scope.openSite = function () {

                    if (typeof window.analytics !== "undefined") window.analytics.trackEvent('Link', 'Site', 'Comprecar', 'http://www.comprecar.com.br/');
     
                window.open('http://www.comprecar.com.br', '_system');
            }


        });

