
angular.module('comprecar.search.ctrl', [])


        .controller('SearchController', ['$scope', '$ionicLoading', '$rootScope', '$state', '$ionicViewService', '$localstorage', '$cordovaDialogs', function ($scope, $ionicLoading, $rootScope, $state, $ionicViewService, $localstorage, $cordovaDialogs) {


                $ionicViewService.clearHistory();

                $scope.data = {};

                $scope.data.city = $localstorage.get('city', "");
                $scope.data.city_id = $localstorage.get('city_id', "");
                $scope.data.type = $localstorage.get('type', "");
                $scope.data.type_id = $localstorage.get('type_id', "");
                $scope.data.keyword = $localstorage.get('keyword', "");

                $scope.data.customer = $localstorage.get('customer', "");
                $scope.data.customer_type = $localstorage.get('customer_type', "");

                $scope.data.price = $localstorage.get('price', "");
                $scope.data.price_min = $localstorage.get('price_min', 0);
                $scope.data.price_max = $localstorage.get('price_max', 0);

                $scope.data.year = $localstorage.get('year', "");
                $scope.data.year_min = $localstorage.get('year_min', 0);
                $scope.data.year_max = $localstorage.get('year_max', 0);

                

                $scope.search = function () {

                    $localstorage.set('city', $scope.data.city);
                    $localstorage.set('city_id', $scope.data.city_id);
                    $localstorage.set('type', $scope.data.type);
                    $localstorage.set('type_id', $scope.data.type_id);
                    $localstorage.set('keyword', $scope.data.keyword + "");
                    $localstorage.set('price', $scope.data.price);
                    $localstorage.set('price_min', $scope.data.price_min);
                    $localstorage.set('price_max', $scope.data.price_max);

                    $localstorage.set('year', $scope.data.year);
                    $localstorage.set('year_min', $scope.data.year_min);
                    $localstorage.set('year_max', $scope.data.year_max);

                    $localstorage.set('customer', $scope.data.customer);

                    $localstorage.set('customer_type', $scope.data.customer_type);

                    // save history search
                    var objHistory = $localstorage.getObject('historySearch');
                    var objHistory = objHistory.length > 0 ? objHistory : [];

                    moment.locale('pt-br');
                    var today = moment();
                    var time = today.format('D/M/YYYY H:mm:ss ');
                    var id = objHistory.length;
                    var data = $scope.data;

                    var historyItem = {id: id, data: data, time: time}
                    objHistory.push(historyItem);
                    $localstorage.setObject('historySearch', objHistory);


                    $rootScope.data = $scope.data;
                    $rootScope.header_title = ($scope.data.title) ? "\"" + $scope.data.title + "\"" : 'Resultado';
                    $rootScope.search = 1;

                    $state.go('app.result');
                };

                $scope.city = function (id) {
                    $state.go('app.cidade');
                };

                $scope.type = function (id) {
                    $state.go('app.tipo');
                };
                $scope.price = function () {
                    $state.go('app.price');
                };

                $scope.ano = function () {
                    $state.go('app.ano');
                };
                $scope.vendedor = function () {
                    $state.go('app.vendedor');
                };


                $scope.clearSearch = function () {
                    
                    $scope.data = {};
                    
                    $scope.data.city = "";
                    $localstorage.set('city', "");
                    $scope.data.city_id = "";
                    $localstorage.set('city_id', "");
                    $scope.data.type = "";
                    $localstorage.set('type', "");
                    $scope.data.type_id = "";
                    $localstorage.set('type_id', "");
                    $scope.data.keyword = "";
                    $localstorage.set('keyword', "");

                    $scope.data.customer = "";
                    $localstorage.set('customer', "");
                    $scope.data.customer_type = "";
                    $localstorage.set('customer_type', "");

                    $scope.data.price = "";
                    $localstorage.set('price', "");
                    $scope.data.price_min = "";
                    $localstorage.set('price_min', 0);
                    $scope.data.price_max = "";
                    $localstorage.set('price_max', 0);

                    $scope.data.year = "";
                    $localstorage.set('year', "");
                    $scope.data.year_min = "";
                    $localstorage.set('year_min', 0);
                    $scope.data.year_max = "";
                    $localstorage.set('year_max', 0);
                 
                }

            }]);