angular.module('comprecar.auth.srv', ['http-auth-interceptor'])
        .factory('AuthenticationService', function ($rootScope, $http, authService, $httpBackend, $cordovaDialogs, $localstorage, CONSTANTS,$ionicLoading) {
            var service = {
                currentUser: {},
                init: function () {
                    var self = this;
                    var user = $localstorage.getObject('user');

                    if (user.length >0) {
                        $http.defaults.headers.common['X-XSRF-TOKEN'] = user.token ;
                    }

                },
                login: function (user) {
                    
                    $ionicLoading.show({
                        template: '<i class="icon ion-loading-c"></i><br />',
                        animation: 'fade-in',
                        showBackdrop: true
                    });
                    $http.post(CONSTANTS.HOST + '/login', user, {ignoreAuthModule: true})
                            .success(function (data, status, headers, config) {
                                $ionicLoading.hide();
                                $http.defaults.headers.common['X-XSRF-TOKEN'] = data.token;

                                authService.loginConfirmed(data, function (config) {  // Step 2 & 3

                                    $localstorage.setObject('user', data.result);
                                    $rootScope.user = $localstorage.getObject('user');
                                    config.headers['X-XSRF-TOKEN'] = data.result.token;
                                    return config;
                                });

                            })
                            .error(function (data, status, headers, config) {
                                $ionicLoading.hide();
                                var msg = (data.message) ? data.message : 'Verifique sua conexão';
                                $cordovaDialogs.alert(msg, 'Comprecar ', 'Voltar')
                                        .then(function () {
                                        });
                                $rootScope.$broadcast('event:auth-login-failed', status);
                            });
                },
                logout: function (user) {

                    delete $http.defaults.headers.common['X-XSRF-TOKEN'];
                    $localstorage.clear();
                    $rootScope.$broadcast('event:auth-logout-complete');

                },
                loginCancelled: function () {
                    authService.loginCancelled();
                }
            };
            return service;
        });