
angular.module('comprecar.cars.srv', [])
        .factory('Cars', ['$http', '$localstorage', '$string', 'CONSTANTS', '$ionicModal', '$ionicLoading', '$cordovaClipboard', function ($http, $localstorage, $string, CONSTANTS, $ionicModal, $ionicLoading, $cordovaClipboard) {

                var headers = {
                    'Content-Type': 'application/json',
                    'Accept': 'application/json'
                };
                var timeout = 20000;

                return {
                    get: function (id) {
                        return $http.get(CONSTANTS.HOST + '/cars/' + id, {
                            timeout: timeout,
                            headers: headers
                        });
                    },
                    getAll: function (data) {
                        return $http.get(CONSTANTS.HOST + '/cars/?' + $string.serialize(data, false), {
                            timeout: timeout,
                            headers: headers
                        });
                    },
                    search: function (data) {
                        return $http.get(CONSTANTS.HOST + '/cars/?' + $string.serialize(data, true), {
                            timeout: timeout,
                            headers: headers
                        });
                    },
                    create: function (data) {
                        var user = $localstorage.getObject('user');
                        $http.defaults.headers.common['X-XSRF-TOKEN'] = user.token;

                        return $http.post(CONSTANTS.HOST + '/cars', data, {
                            timeout: timeout,
                            headers: headers
                        });
                    },
                    edit: function (id, data) {
                        return $http.put('https://api.parse.com/1/classes/Todo/' + id, data, {
                            headers: headers
                        });
                    },
                    delete: function (id) {
                        return $http.delete('https://api.parse.com/1/classes/Todo/' + id, {
                            headers: headers
                        });
                    },
                    addBookmark: function (id, el) {

                        var el = angular.element(document.querySelectorAll('.iconBookmark' + id + ''));
                        var getBookmark = $localstorage.getObject('bookmark');
                        var bookmark = getBookmark.length > 0 ? getBookmark : [];
                        var save = true;

                        angular.forEach(bookmark, function (item) {
                            if (item.id == id) {
                                save = false;
                            }
                        });

                        el.removeClass('ion-ios7-heart-outline');
                        el.addClass('ion-ios7-heart');

                        if (save) {
                            bookmark.push({id: id});
                            $localstorage.setObject('bookmark', bookmark);
                        } else {

                            var getBookmark = $localstorage.getObject('bookmark');
                            var bookmark = getBookmark.length > 0 ? getBookmark : [];
                            var newBookmark = [];

                            angular.forEach(bookmark, function (item) {
                                if (item.id != id) {
                                    newBookmark.push({id: item.id});
                                }
                            });
                            el.addClass('ion-ios7-heart-outline');
                            el.removeClass('ion-ios7-heart');

                            $localstorage.setObject('bookmark', newBookmark);
                        }
                    },
                    removeBookmark: function (id) {
                        var getBookmark = $localstorage.getObject('bookmark');
                        var bookmark = getBookmark.length > 0 ? getBookmark : [];
                        var newBookmark = [];

                        angular.forEach(bookmark, function (item) {
                            if (item.id != id) {
                                newBookmark.push({id: item.id});
                            }
                        });
                        $localstorage.setObject('bookmark', newBookmark);
                        var target = angular.element(document.querySelector('#card' + id + ''));

                        target.addClass('closed');
                        setTimeout(function () {
                            target.remove();
                        }, 500);
                    },
                    callPhone: function (phone) { 


                        phone = phone.replace(/\D/g,'');
                        phone = phone.substr(0, 11);
                        $ionicLoading.show({
                            template: 'Copiado',
                            animation: 'fade-in'
                        });
 
                        $cordovaClipboard
                                .copy(phone)
                                .then(function () {
                                    
                                });

                        setTimeout(function () {
                                       $ionicLoading.hide();
                                    }, 1500);

                        //window.open('tel:' + phone);
                    },
                }
            }])

        .value('CARS_CREDENTIALS', {
            APP_ID: 'xhTpJiNedJ7mmDj3LTTBUePqSVegcJHzEbh70Y0Q',
            REST_API_KEY: 'XCfQDPODgNB1HqmaCQgKLPWGxQ0lCUxqffzzURJY'
        });


    