angular.module('comprecar.contact.modal', [])
        .factory('ContactModal', function ($rootScope, $cordovaDialogs, $localstorage, CONSTANTS, $ionicLoading, $ionicModal, ContactSrc) {
            var service = {
                init: function () {
                    $ionicModal.fromTemplateUrl('app/details/message_modal.html', {
                        scope: $rootScope
                    }).then(function (modal) {
                        $rootScope.modalMsg = modal;
                    });

                    $rootScope.closeMessage = function () {
                        $rootScope.modalMsg.hide();
                    };
                },
                sendMessage: function () {
                    $ionicLoading.show({
                        template: '<i class="icon ion-loading-c"></i>',
                        animation: 'fade-in'
                    });
                    
                    var contactData = {};
                    contactData.veiculo = $rootScope.contact.veiculo;
                    contactData.email = $rootScope.contact.email;
                    contactData.mensagem = $rootScope.contact.mensagem;
                    contactData.telefone = $rootScope.contact.telefone;
                    contactData.nome = $rootScope.contact.nome;
                    
                    $localstorage.setObject('contact', contactData);

                    ContactSrc.create(contactData)
                            .success(function (data) {
                                $ionicLoading.hide();
                                if (data.status == 1) {

                                    $cordovaDialogs.alert(data.message, 'Comprecar ', 'Voltar')
                                            .then(function () {
                                                $rootScope.closeMessage();
                                            });

                                } else {
                                    $rootScope.closeMessage();
                                }
                            })
                            .error(function (err) {
                                $ionicLoading.hide();
                                $cordovaDialogs.alert(err.message, 'Comprecar ', 'Voltar')
                                        .then(function () {
                                            $rootScope.closeMessage();
                                        });
                            });
                },
                createMessage: function (id) {
                    $rootScope.contact = {};
                    var contact = $localstorage.getObject('contact');
                    
                    if (contact) {
                        $rootScope.contact = contact;
                    } 
                    $rootScope.contact.aceita_news = true;
                    $rootScope.contact.veiculo = id;
                    $rootScope.modalMsg.show();
                }
            };
            return service;
        });